(* To start Flyspeck session:

cd ~cek/hh/ses/fly3511c./
rlwrap ~/usr/bin/dmtcp_restart ckpt_hl.dmtcp

or

cd ~cek/hh/ses/hl193./

*)

Sys.chdir "/home/students/mfaerber/hh2/tactics/hol_light";;

#use "metis_tactic.ml";;
#use "leancop.ml";;

Sys.chdir "../eval";;

#use "utils.ml";;
#use "provers.ml";;
#use "parallel.ml";;

let probs = load_atpdeps "fly3511c/deps.atp.fly3511c.provable";;
let probs = load_atpdeps "hl193/deps.atp.hl193.provable";;

let provers =
  [ Meson (Splitlimit 8)
  ; Metis (Splitlimit 0)
  ; Metis (Splitlimit 8)
  ; Leancop (Cut true)
  ; Leancop (Cut false)
  ] ;;

(* NOTE: create appropriate directories before yourself! *)
run_provers (Utils.Timeout  5.0) 47 probs "/tmp/05s" provers;;
run_provers (Utils.Timeout 30.0) 47 probs "/tmp/30s" provers;;

(*
process (Utils.Timeout 5.0) 47 probs "/tmp/5s" (Metis (Splitlimit 0));;
process (Utils.Timeout 5.0) 47 probs "/tmp/5s" (Leancop (Cut false));;
*)
