needs "metis/Portable.ml";;
needs "metis/Option.ml";;
needs "metis/Order.ml";;
needs "metis/Int.ml";;
needs "metis/Real.ml";;
needs "metis/Word.ml";;
needs "metis/Math.ml";;
needs "metis/Mlist.ml";;
needs "metis/Useful.ml";;
needs "metis/Pmap.ml";;
needs "metis/Pset.ml";;
needs "metis/Mmap.ml";;
needs "metis/Intmap.ml";;
needs "metis/Stringmap.ml";;
needs "metis/Mset.ml";;
needs "metis/Intset.ml";;
needs "metis/Sharing.ml";;
needs "metis/Heap.ml";;
needs "metis/Name.ml";;
needs "metis/Name_arity.ml";;
needs "metis/Term.ml";;
needs "metis/Substitute.ml";;
needs "metis/Atom.ml";;
needs "metis/Formula.ml";;
needs "metis/Literal.ml";;
needs "metis/Thm.ml";;
needs "metis/Proof.ml";;
needs "metis/Rule.ml";;
needs "metis/Model.ml";;
needs "metis/Term_net.ml";;
needs "metis/Atom_net.ml";;
needs "metis/Literal_net.ml";;
needs "metis/Subsume.ml";;
needs "metis/Knuth_bendix_order.ml";;
needs "metis/Rewrite.ml";;
needs "metis/Units.ml";;
needs "metis/Clause.ml";;
needs "metis/Ax_cj.ml";;
needs "metis/Active.ml";;
needs "metis/Waiting.ml";;
needs "metis/Resolution.ml";;


module Metis =
struct

type timeout_t = Timeout of float

let new_timer (Timeout t) =
  let start = Sys.time () in
  let check () =
    let now = Sys.time () in
    now >= start +. t
  in check

let rec loop timeup res =
  match Resolution.iterate res with
    Resolution.Decided dec -> Some dec
  | Resolution.Undecided res -> if timeup () then None else loop timeup res

open Ax_cj

let run timeout rules =
  let ths = {axioms_thm = rules; conjecture_thm = []} in
  let res = Resolution.newResolution Resolution.default ths
  and timer = new_timer timeout in
  match loop timer res with
    None -> failwith "Metis: timeout"
  | Some (Resolution.Contradiction thm) -> thm
  | Some (Resolution.Satisfiable _) ->
      failwith "Metis: found satisfiable assignment"

end
