#!/bin/bash
set -e

# wrap an OCaml file (read from stdin) in a module with given name
modulate ()
{
  echo "module $1 = struct"
  echo
  cat -
  echo
  echo "end"
  echo
}

if [ "$#" -ne 2 ]; then
  echo "Install Metis into a HOL Light installation."
  echo "Usage: $0 <metis-src-path> <hol-light-metis-path>"
  echo "Example: $0 metis/src hol_light/metis"
  exit
fi

IN=$1   # e.g. metis/src
OUT=$2  # e.g. hol_light/metis
for i in $IN/*.ml
do
  modulate `basename $i .ml` < $i > $OUT/`basename $i`
done
